uniform extern texture SourceTexture;

sampler TextureSampler = sampler_state
{
    Texture = <SourceTexture>;    
};

uniform extern texture BlendTexture1;

sampler BlendSampler1 = sampler_state
{
    Texture = <BlendTexture1>;    
};

uniform extern texture BlendTexture2;

sampler BlendSampler2 = sampler_state
{
    Texture = <BlendTexture2>;    
};

int Offset;

float4 SourceColor1;
float4 SourceColor2;
float4 SourceColor3;
float4 SourceColor4;

float4 PaletteColor1;
float4 PaletteColor2;
float4 PaletteColor3;
float4 PaletteColor4;

float4 PixelShaderFunction(float2 texCoord: TEXCOORD0) : COLOR
{
float4 SourcePixel = tex2D(TextureSampler, texCoord);
if (abs(SourcePixel.r - SourceColor1.r) < 0.01f && abs(SourcePixel.g - SourceColor1.g) < 0.01f &&abs(SourcePixel.b - SourceColor1.b) < 0.01f )
return PaletteColor1;
else if (abs(SourcePixel.r - SourceColor2.r) < 0.01f && abs(SourcePixel.g - SourceColor2.g) < 0.01f &&abs(SourcePixel.b - SourceColor2.b) < 0.01f )
return PaletteColor2;
else if (abs(SourcePixel.r - SourceColor3.r) < 0.01f && abs(SourcePixel.g - SourceColor3.g) < 0.01f &&abs(SourcePixel.b - SourceColor3.b) < 0.01f )
return PaletteColor3;
else if (abs(SourcePixel.r - SourceColor4.r) < 0.01f && abs(SourcePixel.g - SourceColor4.g) < 0.01f &&abs(SourcePixel.b - SourceColor4.b) < 0.01f )
return PaletteColor4;
else
return SourcePixel;
}
technique Technique1
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}